package assertions;

import domain.*;

public class InclusionAssertion {
	private Included left;
	private Including right;
	
	public InclusionAssertion(Included left, Including right) {
		super();
		this.left = left;
		this.right = right;
	}
	
	
	public Included getLeft() {
		return left;
	}

	public void setLeft(Included left) {
		this.left = left;
	}

	public Including getRight() {
		return right;
	}

	public void setRight(Including right) {
		this.right = right;
	}



	public boolean isConceptInclusion() {
		if (left instanceof BasicConcept) return true;
		else return false;
	}
	
	public boolean isRoleInclusion() {
		if (left instanceof BasicRole) return true;
		else return false;
	}
	
	public boolean isValueDomainInclusion() {
		if (left instanceof BasicValueDomain) return true;
		else return false;
	}
	
	public boolean isConceptAttributeInclusion() {
		if (left instanceof AtomicConceptAttribute) return true;
		else return false;
	}
	
	public boolean isRoleAttributeInclusion() {
		if (left instanceof AtomicRoleAttribute) return true;
		else return false;
	}
	
	public String toString() {
		return left.toString()+" ISA "+right;
	}	
	
}
