package tbox;

import java.util.*;

import domain.AtomicConcept;
import domain.AtomicConceptAttribute;
import domain.AtomicRole;
import domain.AtomicRoleAttribute;
import domain.AtomicValueDomain;

public class Alfabeth {
	private Collection<AtomicConcept> concepts;
	private Collection<AtomicRole> roles;
	private Collection<AtomicValueDomain> valueSets;
	private Collection<AtomicConceptAttribute> conceptAttributes;
	private Collection<AtomicRoleAttribute> roleAttributes;
	
	
	
	public Alfabeth() {
		super();
		this.concepts = new Vector<AtomicConcept>();
		this.roles = new Vector<AtomicRole>();;
		this.valueSets = new Vector<AtomicValueDomain>();
		this.conceptAttributes = new Vector<AtomicConceptAttribute>();
		this.roleAttributes = new Vector<AtomicRoleAttribute>();
	}



	public Alfabeth(Vector<AtomicConcept> concepts, Vector<AtomicRole> roles,
			Vector<AtomicValueDomain> valueSets,
			Vector<AtomicConceptAttribute> conceptAttributes,
			Vector<AtomicRoleAttribute> roleAttributes) {
		super();
		this.concepts = concepts;
		this.roles = roles;
		this.valueSets = valueSets;
		this.conceptAttributes = conceptAttributes;
		this.roleAttributes = roleAttributes;
	}



	public Collection<AtomicConcept> getConcepts() {
		return concepts;
	}



	public void setConcepts(Collection<AtomicConcept> concepts) {
		this.concepts = concepts;
	}



	public Collection<AtomicRole> getRoles() {
		return roles;
	}



	public void setRoles(Collection<AtomicRole> roles) {
		this.roles = roles;
	}



	public Collection<AtomicValueDomain> getValueSets() {
		return valueSets;
	}



	public void setValueSets(Collection<AtomicValueDomain> valueSets) {
		this.valueSets = valueSets;
	}



	public Collection<AtomicConceptAttribute> getConceptAttributes() {
		return conceptAttributes;
	}



	public void setConceptAttributes(
			Collection<AtomicConceptAttribute> conceptAttributes) {
		this.conceptAttributes = conceptAttributes;
	}



	public Collection<AtomicRoleAttribute> getRoleAttributes() {
		return roleAttributes;
	}



	public void setRoleAttributes(Collection<AtomicRoleAttribute> roleAttributes) {
		this.roleAttributes = roleAttributes;
	}
	
	public void add(AtomicConcept a) {
		if(!concepts.contains(a)) this.concepts.add(a);
	}
	
	public void add(AtomicRole p) {
		if(!roles.contains(p)) this.roles.add(p);
	}
	
	public void add(AtomicValueDomain t) {
		if(!valueSets.contains(t)) this.valueSets.add(t);
	}
	
	public void add(AtomicConceptAttribute uc) {
		if(!conceptAttributes.contains(uc)) this.conceptAttributes.add(uc);
	}
	
	public void add(AtomicRoleAttribute ur) {
		if(!roleAttributes.contains(ur)) this.roleAttributes.add(ur);
	}
	
	public String toString() {
		String description = "**Alphabet:";
		description = description.concat("\n  Concepts:           { ");
		Iterator<AtomicConcept> i1 = this.concepts.iterator();
		if (i1.hasNext()) description = description.concat((String)i1.next().toString());
		while(i1.hasNext()) {
			description = description.concat(", " + (String) i1.next().toString());
		}
		description = description.concat("}");
		description = description.concat("\n  Roles:              { ");
		Iterator<AtomicRole> i2 = this.roles.iterator();
		if (i2.hasNext()) description = description.concat((String)i2.next().toString());
		while(i2.hasNext()) {
			description = description.concat(", " + (String) i2.next().toString());
		}
		description = description.concat("}");
		description = description.concat("\n  Value Sets:         { ");
		Iterator<AtomicValueDomain> i3 = this.valueSets.iterator();
		if (i3.hasNext()) description = description.concat((String)i3.next().toString());
		while(i3.hasNext()) {
			description = description.concat(", " + (String) i3.next().toString());
		}
		description = description.concat("}");
		description = description.concat("\n  Concept Attributes: { ");
		Iterator<AtomicConceptAttribute> i4 = this.conceptAttributes.iterator();
		if (i4.hasNext()) description = description.concat((String)i4.next().toString());
		while(i4.hasNext()) {
			description = description.concat(", " + (String) i4.next().toString());
		}
		description = description.concat("}");
		description = description.concat("\n  Role Attributes:    { ");
		Iterator<AtomicRoleAttribute> i5 = this.roleAttributes.iterator();
		if (i5.hasNext()) description = description.concat((String)i5.next().toString());
		while(i5.hasNext()) {
			description = description.concat(", " + (String) i5.next().toString());
		}
		description = description.concat("}");
		return description;
	}
	
	public String toFOLPredicates() {
		String description = "%%**Simboli di predicato:\n";
		Iterator i = this.concepts.iterator();
		if (i.hasNext()) description = description.concat("%% " + (String) i.next().toString() + "/1\n");
		while(i.hasNext()) {
			description = description.concat("%% " + (String) i.next().toString() + "/1\n");
		}
		i = this.roles.iterator();
		if (i.hasNext()) description = description.concat("%% " + (String) i.next().toString() + "/2\n");
		while(i.hasNext()) {
			description = description.concat("%% " + (String) i.next().toString() + "/2\n");
		}
		i = this.conceptAttributes.iterator();
		if (i.hasNext()) description = description.concat("%% " + (String) i.next().toString() + "/2\n");
		while(i.hasNext()) {
			description = description.concat("%% " + (String) i.next().toString() + "/2\n");
		}
		i = this.roleAttributes.iterator();
		if (i.hasNext()) description = description.concat("%% " + (String) i.next().toString() + "/3\n");
		while(i.hasNext()) {
			description = description.concat("%% " + (String) i.next().toString() + "/3\n");
		}
		i = this.valueSets.iterator();
		if (i.hasNext()) description = description.concat("%% " + (String) i.next().toString() + "/1\n");
		while(i.hasNext()) {
			description = description.concat("%% " + (String) i.next().toString() + "/1\n");
		}
		return description;
	}
}
