package translation;

import java.io.*;
import java.io.IOException;
import javax.swing.*;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import tbox.*;


public class Main {

	public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException {
		//String pathxml = args[1];
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("Inserisci path del file XML della TBox:");
		String pathxml = reader.readLine();
		//String pathxml = "./IMDB_TBox.xml";
		TBoxParser parser = new TBoxParser(pathxml);
		TBox tbox = parser.getTbox();
		System.out.println("*************** TBOX DL-LiteA ***************\n");
		System.out.println(tbox.toString());
		System.out.println("*********************************************\n\n");
		String traduzione = FOLTranslator.translate(tbox);
		System.out.println(traduzione);
		
		System.out.println("Inserisci propriet logica da verificare:");
		String proprieta = reader.readLine();
		//String proprieta = new String("all X (Person(X) -> -City(X))");
		
		String nomefileotter = pathxml.substring(0, pathxml.length()-4);
		File otter = new File(nomefileotter+".ott");
		
		Writer out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(otter)),500000);
		out.write("set(auto).\n");
		out.write("formula_list(usable).\n");
		out.write(traduzione);
		out.write("%% Propriet da verificare con OTTER/mace\n");
		out.write("P <-> ("+proprieta+").\n");
		out.write("%% TESI\n");
		out.write("-(P).\n");
		out.write("end_of_list.");
		out.close();
		System.out.println("*********************************************\n\n");
		System.out.println("File otter scritto su disco\n\n");
	}
}
